﻿/*
 * Created by SharpDevelop.
 * User: mvazsonyi
 * Date: 4/10/2018
 * Time: 10:52 PM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.IO;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;



namespace valasztas2018
{
	class Program
	{
		static int count = 0;
		
		public static void Main(string[] args)
		{
			Console.WriteLine("started " + DateTime.Now);
			
			//szkjkv_* fájlok leválogatása
			DirSearch_Copy_szkjkv(@"C:\Users\mvazsonyi\Documents\_____UJ2\PLATONPART\mirror\mirror10\valasztas.hu\dyn\pv18\szavossz\");
			
			Console.WriteLine("DirSearch_Copy_szkjkv " + DateTime.Now);
			Console.WriteLine("fájlok száma: " + count);Console.ReadKey(true);
			JeloltFileParser("szkjkv");Console.ReadKey(true);
			PartlistaFileParser("szkjkv");Console.ReadKey(true);
			OsszesEgysorosFileParser("szkjkv");Console.ReadKey(true);
			
			//Ezek időközben elromlottak, mert a háttérben megbabrálták a HTML struktúrát:
			//EredmenyFileParser("szkjkv");Console.ReadKey(true);
			//JegyzokonyvFileParser("szkjkv");Console.ReadKey(true);
			//AEFEFileParser("szkjkv");Console.ReadKey(true);
			//BOEGEFileParser("szkjkv");Console.ReadKey(true);
			
			Console.Write("Press any key to STOP 2/3 . . . ");
			Console.ReadKey(true);
		}
		
		static void JegyzokonyvFileParser(string d)
		{
			if (File.Exists("jegyzokonyv.csv") == true)
			{
				File.Delete("jegyzokonyv.csv");
			}
			
		    try
		    {
		    	StreamWriter swp = new StreamWriter("jegyzokonyv.csv", false, Encoding.UTF8);
		    	string line;  
		    	string html;
		    	string szkor;
		    	string val;
		    	string filename;
		    	bool van = false;
		    	
	            foreach (string f in Directory.GetFiles(d))
	            {
	            	filename = f;
	            	szkor = "";
	            	val = "";
	            	html = "";
	            	van = false;
	            	
	            	Console.WriteLine(f);
	            	
		            try
	            	{
		            	StreamReader file = new StreamReader(f);
						while((line = file.ReadLine()) != null)  
						{  
							if (line.Contains("szavazókör</h2>"))
							{
								szkor = line.Replace("számú szavazókör</h2>", "")
									.Replace("&ndash;", "-");
							}
							
							if (line.Contains("választókerületi szavazás</h2>"))
							{
								val = line.Replace("<h2>", "")
									.Replace("számú egyéni választókerületi szavazás</h2>", "")
									.Replace("&ndash;", "-");
							}
							
							
							if (line.Contains("<h2>Országos listás szavazás</h2>") == true)
							{
								line = file.ReadLine();
								line = file.ReadLine();
								
								while (line.Contains("<table style=") == false)
								{
									line = file.ReadLine();
								}
								while (line.Contains("</table>") == false)
								{
									van = true;
									html += line;
									line = file.ReadLine();
								}
								
								html += line;
								html = html.Replace("&nbsp;", "").Replace("&ndash;", "-")
									.Replace("<th><br></th>", "<th>ID</th>");
								
								var columns = new List<List<string>>();
								
								XElement table = XElement.Parse(html);
								XElement headings = table.Elements("tr").First(); 
								
								foreach(XElement th in headings.Elements("th"))
								{
								  string heading = th.Value;
								  var column = new List<string>{heading};
								  columns.Add(column);
								}  
								
								foreach(XElement tr in table.Elements("tr").Skip(1))
								{
								 int i = 0;
								
								 foreach(XElement td in tr.Elements("td"))
								 {
								    string value = td.Value;
								    columns[i].Add(value);
								    i++;
								 }
								}
								
								int rows = columns[0].Count;
								int cols = columns.Count;
								
								if (rows < 2 || cols < 2)
								{
									van = false;
								}
								
								for(int i = 1; i < rows; i++)
								{
									string sorx = "";
									sorx += (val + ";" + szkor + ";");
									 for(int j = 0; j < cols; j++)
									 {
									 	Console.Write(columns[j][i].Trim() + ";");
									 	sorx += columns[j][i].Trim() + ";";
									 }
									 
									 swp.WriteLine(sorx);   
									 Console.WriteLine();
								}
								
								break;
							} 
						}
						
						if (van == false)
						{
							Console.WriteLine("nincs: "+filename); Console.ReadKey(false);
						}
					}
				    catch (System.Exception excpt)
				    {
				        Console.WriteLine("fgrasjdf" + excpt.Message);
				        Console.ReadKey(true);
				    }						
	            }
	            
	            swp.Close();
		    }
		    catch (System.Exception excpt)
		    {
		        Console.WriteLine("sghasefads" + excpt.Message);
		        Console.ReadKey(true);
		    }
		}
		
		static void OsszesEgysorosFileParser(string d)
		{
			if (File.Exists("egysorosok.csv") == true)
			{
				File.Delete("egysorosok.csv");
			}
			
			string filename = "";
			
		    try
		    {
		    	StreamWriter swp = new StreamWriter("egysorosok.csv", false, Encoding.UTF8);
//		    	StreamWriter swptest = new StreamWriter("test_egysorosok.csv", false, Encoding.UTF8);
//		    	StreamWriter swptest2 = new StreamWriter("test2_egysorosok.csv", false, Encoding.UTF8);
		    	string line;  
		    	string html;
		    	string szkor;
		    	string val;
		    	bool van = false;
		    	bool orl = false;
		    	
		    	swp.WriteLine("val;szkor;AE;BE;C;EE;FE;IE;JE;JE%;OE;KE;LE;ME;NE;AL;BL;EL;FL;IL;JL;JL%;");
		    	
	            foreach (string f in Directory.GetFiles(d))
	            {
	            	filename = f;
	            	FileInfo fi = new FileInfo(f);
	            	szkor = "";
	            	val = "";
	            	html = "";
	            	orl = false;
	            	
	            	Dictionary<string, string> dict = new Dictionary<string, string>();
											dict.Add("AE", "");
											dict.Add("BE", "");
											dict.Add("C", "");
											dict.Add("EE", "");
											dict.Add("FE", "");
											dict.Add("IE", "");
											dict.Add("JE", "");
											dict.Add("OE", "");
											dict.Add("KE", "");
											dict.Add("LE", "");
											dict.Add("ME", "");
											dict.Add("NE", "");
											dict.Add("AL", "");
											dict.Add("BL", "");
											dict.Add("EL", "");
											dict.Add("FL", "");
											dict.Add("IL", "");
											dict.Add("JL", "");
	            	
	            	Console.WriteLine(f);
	            	van = false;
	            	
	            	try
	            	{
		            	StreamReader file = new StreamReader(f);
		            	
						while((line = file.ReadLine()) != null)  
						{  
							if (line.Contains("A pártlista neve") == true ||
							    line.Contains("A nemzetiségi listák adatai") == true ||
							    line.Contains("c) Szavazás") == true
							   )
							{
								break;
							}
							
							if (line.Contains("Országos listás szavazás") == true)
							{
								orl = true;
							}
							
							html = "";
							if (line.Contains("szavazókör</h2>"))
							{
								szkor = line.Replace("számú szavazókör</h2>", "")
									.Replace("&ndash;", "-");
							}
							
							if (line.Contains("választókerületi szavazás</h2>"))
							{
								val = line.Replace("<h2>", "")
									.Replace("számú egyéni választókerületi szavazás</h2>", "")
									.Replace("&ndash;", "-");
							}
												
							if (line.Contains("<table ") == true)
							{								
								while (line.Contains("</table>") == false)
								{
									van = true;
									html += line;
									line = file.ReadLine();
								}
								html += line;
								html = html.Replace("&nbsp;", "").Replace("&ndash;", "-")
									.Replace("<th><br></th>", "<th>ID</th>")
									.Replace("<br>", " ").Replace("+","").Replace(" / ","");
								
								var columns = new List<List<string>>();
								
								if (html.Contains(".tif") == false &&
								    html.Contains("ORSZÁGGYŰLÉSI KÉPVISELŐK VÁLASZTÁSA") == false &&
								    html.Contains("Pártlistás") == false &&
								    html.Contains("Német") == false &&
								    html.Contains("Lengyel") == false &&
								    html.Contains("Horvát") == false &&
								    html.Contains("Roma") == false
								   )
								{
//									swptest.WriteLine(fi.Name + " " + html);
//									swptest2.WriteLine(fi.Name + "---------------------------" );
									
									XElement table = XElement.Parse(html);
									XElement headings = table.Elements("tr").First(); 
									
									foreach(XElement th in headings.Elements("th"))
									{
									  string heading = th.Value;
									  var column = new List<string>{heading};
									  columns.Add(column);
									}  
									
									foreach(XElement tr in table.Elements("tr").Skip(1))
									{
									 int i = 0;
									
									 foreach(XElement td in tr.Elements("td"))
									 {
									    string value = td.Value;
									    columns[i].Add(value);
									    i++;
									 }
									}
									
									if (columns.Count > 0)
									{
										int rows = columns[0].Count;
										int cols = columns.Count;
										
//										for(int i = 0; i < rows; i++)
//										{
//											swptest2.Write(i+ " || ");
//											for(int j = 0; j < cols; j++)
//											{
//												swptest2.Write(j + " || " + columns[j][i] + " || ");
//											}
//											swptest2.WriteLine();
//										}
										
										for(int i = 1; i < rows; i++)
										{
											string sorx = "";
											
											for(int j = 0; j < cols; j++)
											{									 	
												if (columns[j][i].Contains("%"))
										 		{
										 			sorx = columns[j][i].Trim().Replace("%","")
										 				.Replace(" ", ";");
										 		}
										 		else
										 		{
										 			sorx = columns[j][i].Trim() + ";";
										 		}
												
										 		
										 		
												if (columns[j][0].Contains("A szavazóköri névjegyzékben és a mozgóurnát") == true
										 		   && orl == false)
												{
													dict["AE"] = sorx; van = true;
												}
												else if (columns[j][0].Contains("Átjelentkezett választópolgárok száma") == true
										 		   && orl == false)
												{
													dict["BE"] = sorx; van = true;
												}
												else if (columns[j][0].Contains("A külképviseleti névjegyzékben szerepl") == true
										 		   && orl == false)
												{
													dict["C"] = sorx; van = true;
												}
										 		else if (columns[j][0].Contains("A választópolgárok száma") == true &&
												         columns[j][0].Contains("A választópolgárok száma összesen") == false
										 		   && orl == false)
												{
													dict["EE"] = sorx; van = true;
												}
										 		else if (columns[j][0].Contains("A szavazóhelyiségben és a mozgóurnával szavazó") == true
										 		   && orl == false)
												{
													dict["FE"] = sorx; van = true;
												}
										 		else if (columns[j][0].Contains("Átjelentkezéssel és külképviseleten szavazók beérkezett borítékjainak") == true
										 		   && orl == false)
												{
													dict["IE"] = sorx; van = true;
												}
										 		else if (columns[j][0].Contains("A szavazó választópolgárok száma összesen") == true
										 		   && orl == false)
												{
													dict["JE"] = sorx; van = true;
												}
										 		else if (columns[j][0].Contains("Urnában lévő, bélyegz") == true
										 		   && orl == false)
												{
													dict["OE"] = sorx; van = true;
												}
										 		else if (columns[j][0].Contains("Urnában lévő lebélyegzett szavazólapok") == true
										 		   && orl == false)
												{
													dict["KE"] = sorx; van = true;
												}
										 		else if (columns[j][0].Contains("Eltérés a szavazóként megjelentek") == true
										 		   && orl == false)
												{
													dict["LE"] = sorx; van = true;
												}
										 		else if (columns[j][0].Contains("Érvénytelen szavazólapok száma") == true
										 		   && orl == false)
												{
													dict["ME"] = sorx; van = true;
												}
										 		else if (columns[j][0].Contains("Érvényes szavazólapok száma") == true
										 		   && orl == false)
												{
													dict["NE"] = sorx; van = true;
												}
										 		else if (columns[j][0].Contains("A névjegyzékben lévő választó polgárok") == true
										 		   && orl == true)
												{
													dict["AL"] = sorx; van = true;
												}
										 		else if (columns[j][0].Contains("Átjelentkezett választópolgárok száma") == true
										 		   && orl == true)
												{
													dict["BL"] = sorx; van = true;
												}
										 		else if (columns[j][0].Contains("A választópolgárok száma összesen") == true
										 		   && orl == true)
												{
													dict["EL"] = sorx; van = true;
												}
										 		else if (columns[j][0].Contains("A szavazókörben szavazó") == true
										 		   && orl == true)
												{
													dict["FL"] = sorx; van = true;
												}
										 		else if (columns[j][0].Contains("Átjelentkezéssel és külképviseleten") == true
										 		   && orl == true)
												{
													dict["IL"] = sorx; van = true;
												}
										 		else if (columns[j][0].Contains("A szavazó választópolgárok száma") == true
										 		   && orl == true)
												{
													dict["JL"] = sorx; van = true;
												}
										 		
											}
										}
									}
								}
							} 
						} 
						
						if (van == false)
						{
							Console.WriteLine("nincs: "+filename); Console.ReadKey(false);
						} 
						else
						{		
//swp.WriteLine("val;szkor;AE;BE;C;EE;FE;IE;JE;JE%;OE;KE;LE;ME;NE;AL;BL;EL;FL;IL;JL;JL%;");
							string sor = val + ";" + szkor + ";";
							sor += dict["AE"];
							sor += dict["BE"];
							sor += dict["C"];
							sor += dict["EE"];
							sor += dict["FE"];
							sor += dict["IE"];
							sor += dict["JE"];
							sor += dict["OE"];
							sor += dict["KE"];
							sor += dict["LE"];
							sor += dict["ME"];
							sor += dict["NE"];
							sor += dict["AL"];
							sor += dict["BL"];
							sor += dict["EL"];
							sor += dict["FL"];
							sor += dict["IL"];
							sor += dict["JL"];
							swp.WriteLine(sor);
											
						}
	            	}
	            	catch (System.Exception excpt)
				    {
				        Console.WriteLine("apweflqadf" + filename + ": " + excpt.Message);
				        Console.ReadKey(true);
				    }
	            }
	            
	            swp.Close();
//	            swptest.Close();
		    }
		    catch (System.Exception excpt)
		    {
		        Console.WriteLine("dshasdhb" + excpt.Message);
		        Console.ReadKey(true);
		    }
		}
		
		static void BOEGEFileParser(string d)
		{
			if (File.Exists("BOEGE.csv") == true)
			{
				File.Delete("BOEGE.csv");
			}
			
			string filename = "";
			
		    try
		    {
		    	StreamWriter swp = new StreamWriter("BOEGE.csv", false, Encoding.UTF8);
		    	string line;  
		    	string html;
		    	string szkor;
		    	string val;
		    	
	            foreach (string f in Directory.GetFiles(d))
	            {
	            	filename = f;
	            	szkor = "";
	            	val = "";
	            	html = "";
	            	
	            	Console.WriteLine(f);
	            	
	            	try
	            	{
		            	StreamReader file = new StreamReader(f);
						while((line = file.ReadLine()) != null)  
						{  
							if (line.Contains("szavazókör</h2>"))
							{
								szkor = line.Replace("számú szavazókör</h2>", "")
									.Replace("&ndash;", "-");
							}
							
							if (line.Contains("választókerületi szavazás</h2>"))
							{
								val = line.Replace("<h2>", "")
									.Replace("számú egyéni választókerületi szavazás</h2>", "")
									.Replace("&ndash;", "-");
							}
												
							if (line.Contains(">Átjelentkezett választópolgárok</p>") == true)
							{
								line = file.ReadLine();
								
								while (line.Contains("</table>") == false)
								{
									html += line;
									line = file.ReadLine();
								}
								html += line;
								html = html.Replace("&nbsp;", "").Replace("&ndash;", "-")
									.Replace("<th><br></th>", "<th>ID</th>")
									.Replace("<br>", " ");
								
								var columns = new List<List<string>>();
								
								XElement table = XElement.Parse(html);
								XElement headings = table.Elements("tr").First(); 
								
								foreach(XElement th in headings.Elements("th"))
								{
								  string heading = th.Value;
								  var column = new List<string>{heading};
								  columns.Add(column);
								}  
								
								foreach(XElement tr in table.Elements("tr").Skip(1))
								{
								 int i = 0;
								
								 foreach(XElement td in tr.Elements("td"))
								 {
								    string value = td.Value;
								    columns[i].Add(value);
								    i++;
								 }
								}
								
								int rows = columns[0].Count;
								int cols = columns.Count;
								
								for(int i = 1; i < rows; i++)
								{
									string sorx = "";
									sorx += (val + ";" + szkor + ";");
									 for(int j = 0; j < cols; j++)
									 {
								 		Console.Write(columns[j][i].Trim() + ";");
								 		
								 		if (j == cols - 1)
								 		{
								 			sorx += columns[j][i].Trim().Replace("%","")
								 				.Replace(" ", ";");
								 		}
								 		else
								 		{
								 			sorx += columns[j][i].Trim() + ";";
								 		}
									 }
									 
									 swp.WriteLine(sorx);   
									 Console.WriteLine();
								}
								
								break;
							} 
						} 
	            	}
	            	catch (System.Exception excpt)
				    {
				        Console.WriteLine("adfddfad" + filename + ": " + excpt.Message);
				        Console.ReadKey(true);
				    }
	            }
	            
	            swp.Close();
		    }
		    catch (System.Exception excpt)
		    {
		        Console.WriteLine("ghkfjwww" + excpt.Message);
		        Console.ReadKey(true);
		    }
		}
		
		static void AEFEFileParser(string d)
		{
			if (File.Exists("AEFE.csv") == true)
			{
				File.Delete("AEFE.csv");
			}
			
			string filename = "";
			
		    try
		    {
		    	StreamWriter swp = new StreamWriter("AEFE.csv", false, Encoding.UTF8);
		    	string line;  
		    	string html;
		    	string szkor;
		    	string val;
		    	bool van = false;
		    	string memo1 = "";
		    	string memo2 = "";
		    	
	            foreach (string f in Directory.GetFiles(d))
	            {
	            	filename = f;
	            	szkor = "";
	            	val = "";
	            	html = "";
	            	memo1 = "";
	            	memo2 = "";
	            	
	            	Console.WriteLine(f);
	            	van = false;
	            	
	            	try
	            	{
		            	StreamReader file = new StreamReader(f);
						while((line = file.ReadLine()) != null)  
						{  
							if (line.Contains("szavazókör</h2>"))
							{
								szkor = line.Replace("számú szavazókör</h2>", "")
									.Replace("&ndash;", "-");
							}
							
							if (line.Contains("választókerületi szavazás</h2>"))
							{
								val = line.Replace("<h2>", "")
									.Replace("számú egyéni választókerületi szavazás</h2>", "")
									.Replace("&ndash;", "-");
							}
												
							if (line.Contains(">A szavazókörben lakcímmel rendelkez") == true)
							{
								line = file.ReadLine();
								
								while (line.Contains("</table>") == false)
								{
									van = true;
									html += line;
									line = file.ReadLine();
								}
								html += line;
								html = html.Replace("&nbsp;", "").Replace("&ndash;", "-")
									.Replace("<th><br></th>", "<th>ID</th>")
									.Replace("<br>", " ");
								
								var columns = new List<List<string>>();
								
								XElement table = XElement.Parse(html);
								XElement headings = table.Elements("tr").First(); 
								
								foreach(XElement th in headings.Elements("th"))
								{
								  string heading = th.Value;
								  var column = new List<string>{heading};
								  columns.Add(column);
								}  
								
								foreach(XElement tr in table.Elements("tr").Skip(1))
								{
								 int i = 0;
								
								 foreach(XElement td in tr.Elements("td"))
								 {
								    string value = td.Value;
								    columns[i].Add(value);
								    i++;
								 }
								}
								
								int rows = columns[0].Count;
								int cols = columns.Count;
								
								for(int i = 1; i < rows; i++)
								{
									string sorx = "";
									sorx += (val + ";" + szkor + ";");
									 for(int j = 0; j < cols; j++)
									 {
								 		Console.Write(columns[j][i].Trim() + ";");
								 		
								 		if (j == cols - 1)
								 		{
								 			sorx += columns[j][i].Trim().Replace("%","")
								 				.Replace(" ", ";");
								 		}
								 		else
								 		{
								 			sorx += columns[j][i].Trim() + ";";
								 		}
									 }
									 
									 swp.WriteLine(sorx);   
									 Console.WriteLine();
								}
								
								break;
							} 
							else if (line.Contains("A névjegyzékben és a mozgóurnát igényl") == true)
							{
								line = memo2 + memo1 + line;
								
								while (line.Contains("</table>") == false)
								{
									van = true;
									if(line.Contains("A szavazás eredménye</p>") == true)
									{
										line = file.ReadLine();
									}
									else
									{
										html += line;
										line = file.ReadLine();
									}
								}
								html += line;
								html = html.Replace("&nbsp;", "").Replace("&ndash;", "-")
									.Replace("<th><br></th>", "<th>ID</th>")
									.Replace("<br>", " ");
								
								var columns = new List<List<string>>();
								
								XElement table = XElement.Parse(html);
								XElement headings = table.Elements("tr").First(); 
								
								foreach(XElement th in headings.Elements("th"))
								{
								  string heading = th.Value;
								  var column = new List<string>{heading};
								  columns.Add(column);
								}  
								
								foreach(XElement tr in table.Elements("tr").Skip(1))
								{
								 int i = 0;
								
								 foreach(XElement td in tr.Elements("td"))
								 {
								    string value = td.Value;
								    columns[i].Add(value);
								    i++;
								 }
								}
								
								int rows = columns[0].Count;
								int cols = columns.Count;
								
								for(int i = 1; i < rows; i++)
								{
									string sorx = "";
									sorx += (val + ";" + szkor + ";");
									 for(int j = 0; j < cols; j++)
									 {
									 	if (j == 0 &&
									 	    columns[j][0]
									 	    .Contains("átjelentkezéssel leadott szavazatot") == false
									 	   )
										{
									 		Console.Write(";" + columns[j][i].Trim() + ";");
										 	sorx += ";" + columns[j][i].Trim() + ";";
										 	
										}
									 	else
									 	{
									 		Console.Write(columns[j][i].Trim() + ";");
										 	sorx += columns[j][i].Trim() + ";";
									 	}
									 	
									 }
									 
									 swp.WriteLine(sorx);   
									 Console.WriteLine();
								}
								
								break;
							}
							memo2 = memo1;
							memo1 = line;
						} 
						
						if (van == false)
						{
							Console.WriteLine("nincs: "+filename); Console.ReadKey(false);
						}
	            	}
	            	catch (System.Exception excpt)
				    {
				        Console.WriteLine("apweflqadf" + filename + ": " + excpt.Message);
				        Console.ReadKey(true);
				    }
	            }
	            
	            swp.Close();
		    }
		    catch (System.Exception excpt)
		    {
		        Console.WriteLine("dshasdhb" + excpt.Message);
		        Console.ReadKey(true);
		    }
		}
		
		static void EredmenyFileParser(string d)
		{
			if (File.Exists("eredmenyek.csv") == true)
			{
				File.Delete("eredmenyek.csv");
			}
			
			string filename = "";
			
		    try
		    {
		    	StreamWriter swp = new StreamWriter("eredmenyek.csv", false, Encoding.UTF8);
		    	string line;  
		    	string html;
		    	string szkor;
		    	string val;
		    	bool van = false;
		    	string memo1 = "";
		    	string memo2 = "";
		    	
	            foreach (string f in Directory.GetFiles(d))
	            {
	            	filename = f;
	            	szkor = "";
	            	val = "";
	            	html = "";
	            	bool jkv = false;
	            	memo1 = "";
	            	memo2 = "";
	            	Console.WriteLine(f);
	            	van = false;
	            	
	            	try
	            	{
		            	StreamReader file = new StreamReader(f);
						while((line = file.ReadLine()) != null)  
						{  
							if (line.Contains("szavazókör</h2>"))
							{
								szkor = line.Replace("számú szavazókör</h2>", "")
									.Replace("&ndash;", "-");
							}
							
							if (line.Contains("választókerületi szavazás</h2>"))
							{
								val = line.Replace("<h2>", "")
									.Replace("számú egyéni választókerületi szavazás</h2>", "")
									.Replace("&ndash;", "-");
							}
							
//							if (line.Contains("<h3>Jegyzőkönyv</h3>") == true)
//							{
//								jkv = true;
//							}
												
							if (//jkv == true && 
							    (line.Contains("A szavazás eredménye</p>") == true)
							   )
							{
								line = file.ReadLine();
//								
//								if (line.Contains("Átjelentkezett választópolgárok</p>") == true)
//								{
//									while (line.Contains("</table>") == false)
//									{
//										line = file.ReadLine();
//									}
//									line = file.ReadLine();
//									Console.WriteLine();
//								}
								
								while (line.Contains("</table>") == false)
								{
									van = true;
									if(line.Contains("A szavazás eredménye</p>") == true)
									{
										line = file.ReadLine();
									}
									else
									{
										html += line;
										line = file.ReadLine();
									}
								}
								html += line;
								html = html.Replace("&nbsp;", "").Replace("&ndash;", "-")
									.Replace("<th><br></th>", "<th>ID</th>")
									.Replace("<br>", " ");
								
								var columns = new List<List<string>>();
								
								XElement table = XElement.Parse(html);
								XElement headings = table.Elements("tr").First(); 
								
								foreach(XElement th in headings.Elements("th"))
								{
								  string heading = th.Value;
								  var column = new List<string>{heading};
								  columns.Add(column);
								}  
								
								foreach(XElement tr in table.Elements("tr").Skip(1))
								{
								 int i = 0;
								
								 foreach(XElement td in tr.Elements("td"))
								 {
								    string value = td.Value;
								    columns[i].Add(value);
								    i++;
								 }
								}
								
								int rows = columns[0].Count;
								int cols = columns.Count;
								
								for(int i = 1; i < rows; i++)
								{
									string sorx = "";
									sorx += (val + ";" + szkor + ";");
									 for(int j = 0; j < cols; j++)
									 {
									 	if (j == 0 &&
									 	    columns[j][0]
									 	    .Contains("átjelentkezéssel leadott szavazatot") == false
									 	   )
										{
									 		Console.Write(";" + columns[j][i].Trim() + ";");
										 	sorx += ";" + columns[j][i].Trim() + ";";
										 	
										}
									 	else
									 	{
									 		Console.Write(columns[j][i].Trim() + ";");
										 	sorx += columns[j][i].Trim() + ";";
									 	}
									 	
									 }
									 
									 swp.WriteLine(sorx);   
									 Console.WriteLine();
								}
								
								break;
							} 
							else if (line.Contains("lenyomat nélküli szavazólapok száma</th>") == true)
							{
								line = memo2 + memo1 + line;
								
								while (line.Contains("</table>") == false)
								{
									van = true;
									if(line.Contains("A szavazás eredménye</p>") == true)
									{
										line = file.ReadLine();
									}
									else
									{
										html += line;
										line = file.ReadLine();
									}
								}
								html += line;
								html = html.Replace("&nbsp;", "").Replace("&ndash;", "-")
									.Replace("<th><br></th>", "<th>ID</th>")
									.Replace("<br>", " ");
								
								var columns = new List<List<string>>();
								
								XElement table = XElement.Parse(html);
								XElement headings = table.Elements("tr").First(); 
								
								foreach(XElement th in headings.Elements("th"))
								{
								  string heading = th.Value;
								  var column = new List<string>{heading};
								  columns.Add(column);
								}  
								
								foreach(XElement tr in table.Elements("tr").Skip(1))
								{
								 int i = 0;
								
								 foreach(XElement td in tr.Elements("td"))
								 {
								    string value = td.Value;
								    columns[i].Add(value);
								    i++;
								 }
								}
								
								int rows = columns[0].Count;
								int cols = columns.Count;
								
								for(int i = 1; i < rows; i++)
								{
									string sorx = "";
									sorx += (val + ";" + szkor + ";");
									 for(int j = 0; j < cols; j++)
									 {
									 	if (j == 0 &&
									 	    columns[j][0]
									 	    .Contains("átjelentkezéssel leadott szavazatot") == false
									 	   )
										{
									 		Console.Write(";" + columns[j][i].Trim() + ";");
										 	sorx += ";" + columns[j][i].Trim() + ";";
										 	
										}
									 	else
									 	{
									 		Console.Write(columns[j][i].Trim() + ";");
										 	sorx += columns[j][i].Trim() + ";";
									 	}
									 	
									 }
									 
									 swp.WriteLine(sorx);   
									 Console.WriteLine();
								}
								
								break;
							}
							memo2 = memo1;
							memo1 = line;
						} 
						
						if (van == false)
						{
							Console.WriteLine("nincs: "+filename); Console.ReadKey(false);
						}
	            	}
	            	catch (System.Exception excpt)
				    {
				        Console.WriteLine("asdfasfdasasd" + filename + ": " + excpt.Message);
				        Console.ReadKey(true);
				    }
	            }
	            
	            swp.Close();
		    }
		    catch (System.Exception excpt)
		    {
		        Console.WriteLine("ptzoitpews"+excpt.Message);
		        Console.ReadKey(true);
		    }
		}
		
		static void PartlistaFileParser(string d)
		{
			if (File.Exists("partlistak_2018.csv") == true)
			{
				File.Delete("partlistak_2018.csv");
			}
			
			string filename = "";
			
		    try
		    {
		    	StreamWriter swp = new StreamWriter("partlistak_2018.csv", false, Encoding.UTF8);
		    	string line;  
		    	string html;
		    	string szkor;
		    	string val;
		    	int szavkorcount = 0;
		    	
	            foreach (string f in Directory.GetFiles(d))
	            {
	            	filename = f;
	            	szkor = "";
	            	val = "";
	            	html = "";
	            	
	            	Console.WriteLine(f);
	            	try
		   			{
		            	StreamReader file = new StreamReader(f);
						while((line = file.ReadLine()) != null)  
						{  
							if (line.Contains("szavazókör</h2>"))
							{
								szkor = line.Replace("számú szavazókör</h2>", "")
									.Replace("&ndash;", "-");
							}
							
							if (line.Contains("választókerületi szavazás</h2>"))
							{
								val = line.Replace("<h2>", "")
									.Replace("számú egyéni választókerületi szavazás</h2>", "")
									.Replace("&ndash;", "-");
							}
							
							
							if (line.Contains("A szavazatok száma pártlistánként</p>") == true)
							{
								szavkorcount++;
								
								line = file.ReadLine();
								while (line.Contains("</table>") == false)
								{
									html += line;
									line = file.ReadLine();
								}
								html += line;
								html = html.Replace("&nbsp;", "").Replace("&ndash;", "-")
									.Replace("<th><br></th>", "<th>ID</th>");
								
								var columns = new List<List<string>>();
								
								XElement table = XElement.Parse(html);
								XElement headings = table.Elements("tr").First(); 
								
								foreach(XElement th in headings.Elements("th"))
								{
								  string heading = th.Value;
								  var column = new List<string>{heading};
								  columns.Add(column);
								}  
								
								foreach(XElement tr in table.Elements("tr").Skip(1))
								{
								 int i = 0;
								
								 foreach(XElement td in tr.Elements("td"))
								 {
								    string value = td.Value;
								    columns[i].Add(value);
								    i++;
								 }
								}
								
								int rows = columns[0].Count;
								int cols = columns.Count;
								
								for(int i = 1; i < rows; i++)
								{
									string sorx = "";
									sorx += (val + ";" + szkor + ";");
									 for(int j = 0; j < cols; j++)
									 {
									 	//Console.Write(columns[j][i].Trim() + ";");
									 	sorx += columns[j][i].Trim() + ";";
									 }
								
									 if (sorx.Contains("Pártlistákra leadott") == false)
									 {
										 swp.WriteLine(sorx);   
										 //Console.WriteLine();		
									 }
								}
								
								break;
							} 
						}  
					}
				    catch (System.Exception excpt)
				    {
				        Console.WriteLine("poasasdaadsu"+filename + ": " + excpt.Message);
				        Console.ReadKey(true);
				    }
	            }
	            
	            Console.WriteLine(szavkorcount.ToString());
	            
	            swp.Close();
		    }
		    catch (System.Exception excpt)
		    {
		        Console.WriteLine("dadqwdawdwddaW"+filename + ": " + excpt.Message);
		        Console.ReadKey(true);
		    }
		}
		
		static void JeloltFileParser(string d)
		{
			if (File.Exists("jeloltek_2018.csv") == true)
			{
				File.Delete("jeloltek_2018.csv");
			}
			
		    try
		    {
		    	StreamWriter swj = new StreamWriter("jeloltek_2018.csv", false, Encoding.UTF8);
		    	string line;  
		    	string html;
		    	string szkor;
		    	string val;
		    	
	            foreach (string f in Directory.GetFiles(d))
	            {
	            	szkor = "";
	            	val = "";
	            	html = "";
	            	
	            	Console.WriteLine(f);
	            	
	            	try
		    		{
		            	StreamReader file = new StreamReader(f);
						while((line = file.ReadLine()) != null)  
						{  
							if (line.Contains("szavazókör</h2>"))
							{
								szkor = line.Replace("számú szavazókör</h2>", "")
									.Replace("&ndash;", "-");
							}
							
							if (line.Contains("választókerületi szavazás</h2>"))
							{
								val = line.Replace("<h2>", "")
									.Replace("számú egyéni választókerületi szavazás</h2>", "")
									.Replace("&ndash;", "-");
							}
							
							
							if (line.Contains(">A szavazatok száma jelöltenként</p>") == true)
							{
								line = file.ReadLine();
								while (line.Contains("</table>") == false)
								{
									html += line;
									line = file.ReadLine();
								}
								html += line;
								html = html.Replace("&nbsp;", "");
								
								var columns = new List<List<string>>();
								
								XElement table = XElement.Parse(html);
								XElement headings = table.Elements("tr").First(); 
								
								foreach(XElement th in headings.Elements("th"))
								{
								  string heading = th.Value;
								  var column = new List<string>{heading};
								  columns.Add(column);
								}  
								
								foreach(XElement tr in table.Elements("tr").Skip(1))
								{
								 int i = 0;
								
								 foreach(XElement td in tr.Elements("td"))
								 {
								    string value = td.Value;
								    columns[i].Add(value);
								    i++;
								 }
								}
								
								int rows = columns[0].Count;
								int cols = columns.Count;
								
								for(int i = 1; i < rows; i++)
								{
									swj.Write(val + ";" + szkor + ";");
									 for(int j = 0; j < cols; j++)
									 {
									 	Console.Write(columns[j][i].Trim() + ";");
									 	swj.Write(columns[j][i].Trim() + ";");
									 }
								
								 swj.WriteLine();   
								 Console.WriteLine();							 
								}
								
								break;
							} 
						}
					}
				    catch (System.Exception excpt)
				    {
				        Console.WriteLine("sdgsdgsdgdf"+excpt.Message);
				        Console.ReadKey(true);
				    }					
	            }
	            
	            swj.Close();
		    }
		    catch (System.Exception excpt)
		    {
		        Console.WriteLine("sskljkas"+excpt.Message);
		        Console.ReadKey(true);
		    }
		}
		
		static void DirSearch_Copy_szkjkv(string sDir)
		{
			if (Directory.Exists("szkjkv") == false)
			{
				Directory.CreateDirectory("szkjkv");
			}
			
		    try
		    {
		        foreach (string d in Directory.GetDirectories(sDir))
		        {
		            foreach (string f in Directory.GetFiles(d))
		            {
		            	if (f.Contains("szkjkv_") == true)
		            	{
		            		FileInfo fi = new FileInfo(f);
		            		string target = "szkjkv" + "//" + fi.Name.Replace(".html", "_platon_" + count++ + ".html");
		            		File.Copy(f, target);
		            	}
		            }
		            DirSearch_Copy_szkjkv(d);
		        }
		    }
		    catch (System.Exception excpt)
		    {
		        Console.WriteLine(excpt.Message);
		    }
		}
	}
}